import * as React from "react";
import { SvgIcon } from "../my-icon/index";
class ComboInp extends React.PureComponent {
    constructor() {
        super(...arguments);
        this.state = {
            editVal: this.props.defaultEditVal,
            blurVal: this.props.defaultEditVal,
            preSelected: this.props.selected
        };
        this.clickFn = (e) => {
            e.stopPropagation();
            this.props.clearFn();
        };
        this.changeEditInp = (e) => {
            this.setState({
                editVal: e.currentTarget.value.trim()
            });
            this.props.editFn(e);
        };
        this.blurEditFn = () => {
            const { editVal, blurVal } = this.state;
            if (blurVal === editVal) {
                return;
            }
            const { selected, clearFn } = this.props;
            const val = ComboInp.defaultProps.formatterVal(selected);
            this.setState({
                blurVal: editVal
            }, () => {
                if (val && val !== editVal) {
                    clearFn();
                }
            });
        };
    }
    static getDerivedStateFromProps(nextProps, preState) {
        if (preState.preSelected !== nextProps.selected) {
            const editVal = nextProps.selected.size ? ComboInp.defaultProps.formatterVal(nextProps.selected) : preState.editVal;
            return {
                preSelected: nextProps.selected,
                editVal,
                blurVal: editVal
            };
        }
        return null;
    }
    getSlideIcon(noicon, drop) {
        return !noicon ? (React.createElement(SvgIcon, { className: `arrow-${drop ? "up" : "down"}` })) : undefined;
    }
    getTit(tit) {
        return (React.createElement("span", { className: "combo-inp-tit" }, tit));
    }
    getClearCom(show) {
        return show ? (React.createElement("span", { onClick: this.clickFn, className: "j-close" },
            React.createElement(SvgIcon, { className: `close` }))) : undefined;
    }
    render() {
        const { selected, slideFn, tit, formatterVal, noicon, drop, noRequire, ableClear, disabled, editFn, field } = this.props;
        const { editVal } = this.state;
        const status = noRequire || disabled ? "" : editFn ? editVal ? "" : "no-fill" : selected.size ? "" : "no-fill";
        const clearStatus = !!(ableClear && selected.size);
        const val = selected.size ? formatterVal(selected) : this.getTit(tit);
        return (React.createElement("div", { className: `m-combo-inp ${status} ${disabled ? "disabled" : ""}`, onClick: disabled ? undefined : slideFn },
            React.createElement("div", { className: "combo-value" }, editFn ? React.createElement("input", { disabled: disabled, value: editVal, onBlur: this.blurEditFn, onChange: this.changeEditInp, name: field, className: "edit-combo", placeholder: tit }) : val),
            disabled ? undefined : this.getClearCom(clearStatus),
            this.getSlideIcon(noicon, drop)));
    }
}
ComboInp.defaultProps = {
    formatterVal: (seleted) => seleted.map((val) => val.text).join("，"),
    defaultEditVal: "",
};
export default ComboInp;
