import * as React from "react";
import * as Immutable from "immutable";
import { IMenuData, IfieldObj, Inode, ILinkNode } from "./menu";
import { IImmutalbeMap, IImmutalbeList } from "../util/immutableUtil";
import { IScrollMethods } from "../scroll/scroll";
declare type props = {
    node: IImmutalbeMap<Inode>;
    expand: boolean;
    fieldObj: IfieldObj;
    link?: (node: ILinkNode) => JSX.Element;
    parIndex: number;
    toggleSlide: (index: number) => void;
    scrollInitFn?: IScrollMethods;
    changeData(callback: (data: IImmutalbeList<IImmutalbeMap<Inode>>, selected: string) => {
        data: IImmutalbeList<IImmutalbeMap<Inode>>;
        selected: string;
    }): void;
};
declare type states = {};
interface IParMenu {
    subMenu(children: Immutable.List<IImmutalbeMap<IMenuData>>, parIndex: number): Immutable.List<JSX.Element>;
    getSubCom(): JSX.Element;
}
declare class ParMenu extends React.PureComponent<props, states> implements IParMenu {
    state: states;
    selectItemFn: (e: React.MouseEvent<HTMLSpanElement>) => void;
    subMenu(children: Immutable.List<IImmutalbeMap<IMenuData>>, parIndex: number): Immutable.List<JSX.Element>;
    slideCallback: (isStart?: boolean | undefined) => void;
    getSubCom(): JSX.Element;
    toggleSlide: () => void;
    renderPar(): JSX.Element;
    renderSingleNav(): JSX.Element;
    render(): JSX.Element;
}
export default ParMenu;
