import * as React from "react";
import { SvgIcon } from "../../my-icon/index";
class TrItem extends React.PureComponent {
    constructor() {
        super(...arguments);
        this.state = {};
        this.checkFn = (e) => {
            e.stopPropagation();
            const dom = e.currentTarget;
            const index = dom.dataset.index;
            const { changeState } = this.props;
            changeState(index, "active");
        };
        this.changeSelect = (e) => {
            const index = e.currentTarget.dataset.index;
            this.props.changeState(index, "active");
        };
    }
    getCheck() {
        const { node, index } = this.props;
        const active = node.get("checked") ? "checkbox-marked" : "checkbox-blank";
        return (React.createElement("span", { onClick: this.checkFn, className: "tree-check", "data-index": index },
            React.createElement(SvgIcon, { className: active })));
    }
    getFirstText(text, field) {
        const { index } = this.props;
        if (field === "order") {
            return index;
        }
        else if (field === "check") {
            return this.getCheck();
        }
        else {
            return text;
        }
    }
    render() {
        const { cols, node, fixObj: { tabField, multiply, slectField }, isMainView, index } = this.props;
        const tds = cols.map((td, oindex) => {
            const { field, formatter, align } = td;
            const text = formatter
                ? formatter(node, oindex, tabField, field)
                : node.get(field);
            const str = isMainView ? this.getFirstText(text, field) : text;
            let alignName = align ? `${align}` : "";
            const fn = !multiply && (!slectField ? true : slectField == field) ? this.changeSelect : undefined;
            return (React.createElement("td", { key: field, "data-index": !multiply ? index : undefined, "data-filed": field, className: `td-border ${alignName}`, onClick: fn }, str));
        });
        const selected = !multiply && node.get("checked") ? "selected" : "";
        return React.createElement("tr", { className: `${selected} render-td` }, tds);
    }
}
export default TrItem;
