import React from "react";
import { IImmutalbeMap, IImmutalbeList } from "../../util/immutableUtil";
export interface IColumnItem<T> {
    field: string;
    children: React.ReactNode;
    align?: "center" | "left" | 'right';
    width: number;
    formatter?: (node: IImmutalbeMap<Inode & T>, index: number, tabField: string | undefined, field: string, order: number) => React.ReactChild;
}
declare type group<T> = React.ComponentElement<IColumnItem<T>, React.ComponentState>;
export interface Inode {
    active: 'selected' | 'hasSelect' | 'noSelect';
    expand: boolean;
    order: string;
}
export interface ICommon<T> {
    node: Inode & T;
    data: IImmutalbeList<IImmutalbeMap<ICommon<T>['node']>>;
    col: (Omit<IColumnItem<T>, 'children'> & {
        text: React.ReactNode;
    });
    groupCol: {
        children: group<T>[] | group<T>;
        forzen?: boolean;
        width?: number;
    };
    config: Omit<ICommon<T>['groupCol'], 'children'> & {
        child: ICommon<T>['col'][];
        width: number;
    };
    fixObj: {
        childField: string;
        fileOrder?: boolean;
        slectField?: string;
        noOrder?: boolean;
        multiply?: boolean;
        itemIcon?: string | false | ((node: IImmutalbeMap<ICommon<T>['node']>) => string);
        idField: string;
        defaultSel?: string;
        tabField?: string;
        emptyTxt?: string | ((field?: string) => React.ReactChild);
    };
    changeState(path: string, key: 'expand' | 'active' | 'checkPar'): void;
}
export declare type fieldObj<T> = {
    column: IColumnItem<T>[];
    idField: string;
    noOrder?: boolean;
    checkbox?: boolean;
    tabField?: string;
};
export {};
